#include <unistd.h>
#include "fb.h"
#include "forms.h"
#include "FaxBrowser.h"

/* callbacks for form fb */
void show_fax(FL_OBJECT *ob, long data)
{
    int i, sf;
    char fname[256], ofname[256]="";
    struct faxent *p;
    char *fp;

    /* get current selection */
    get_selection();

    /* handle doubleclick selections */
    sf = fl_get_browser(browser_fax);
    if ((data == 1) && (sf < 0)) {
	p = (struct faxent *) faxentptr[-sf];
	p->status = 1;
    }

    for(i=1; i<=faxnr; i++) {
	p = (struct faxent *) faxentptr[i];
	if (p->status == 1) {
	    strcpy(fname, p->filename);
	    if(fl_get_button(button_multipage)) {
		if ((fp = (char *) strrchr(fname, '.'))) {
		    *fp = '\0';
		    /* filter out the already shown pages of a multi page fax */
		    if (!strcmp(ofname, fname)) continue;
		    strcpy(ofname, fname);
		    strcat(fname, ".*");
		}
	    }
	    process_fax(fname, p->resolution, "view");
	}
    }
}

void load_fax(FL_OBJECT *ob, long data)
{
    char *fname, *p;

    fname = (char *) fl_show_fselector("File To Load",
	    fax_dir, "", "");
    if (fname == NULL) return;

    p = strrchr(fname, '/');
    process_fax(fname, p[2], "view");
}

void print_fax(FL_OBJECT *ob, long data)
{
    int i;
    char fname[256], ofname[256]="";
    char *fp;
    struct faxent *p;

    /* get current selection */
    get_selection();

    for(i=1; i<=faxnr; i++) {
	p = (struct faxent *) faxentptr[i];
	if (p->status == 1) {
	    strcpy(fname, p->filename);
	    if(fl_get_button(button_multipage)) {
		if ((fp = (char *) strrchr(fname, '.'))) {
		    *fp = '\0';
		    /* filter out the already shown pages of a multi page fax */
		    if (!strcmp(ofname, fname)) continue;
		    strcpy(ofname, fname);
		    strcat(fname, ".*");
		}
	    }
	    process_fax(fname, p->resolution, "print");
	}
    } 
}

void delete_fax(FL_OBJECT *ob, long data)
{
    int i;
    char xname[256];
    char xquest[300];
    struct faxent *p;

    /* get current selection */
    get_selection();

    for(i=1; i<=faxnr; i++) {
	p = (struct faxent *) faxentptr[i];
	if (p->status == 1) {
	    strcpy(xname, p->filename);
	    sprintf(xquest, "Do you want to delete\n\n%s", xname);
	    if(fl_show_question(xquest, 1)) {
		if(unlink(xname)) {
		    fl_show_alert("Alert", "Can't remove file",
			strerror(errno), 0);
		}
	    }
	}
    }
    get_filenames();
}

void edit_settings(FL_OBJECT *ob, long data)
{
    int button_m;
    char bakname[256];
    FILE *fd;
    FL_OBJECT *act;

    fl_show_form(settings, FL_PLACE_HOTSPOT,FL_FULLBORDER,
	"FaxBrowser - Settings");

    fl_set_input(input_faxdir, fax_dir);
    fl_set_input(input_faxalias, fax_alias);
    fl_set_input(input_viewcommandn, fax_viewcommandn);
    fl_set_input(input_printcommandn, fax_printcommandn);
    fl_set_input(input_viewcommandf, fax_viewcommandf);
    fl_set_input(input_printcommandf, fax_printcommandf);

    button_m = fl_get_button(button_multipage);

    while (1) {
	act = fl_do_forms();
	if (act == button_use) {
	    strcpy(fax_dir, fl_get_input(input_faxdir));
	    strcpy(fax_alias, fl_get_input(input_faxalias));
	    strcpy(fax_viewcommandn, fl_get_input(input_viewcommandn));
	    strcpy(fax_printcommandn, fl_get_input(input_printcommandn));
	    strcpy(fax_viewcommandf, fl_get_input(input_viewcommandf));
	    strcpy(fax_printcommandf, fl_get_input(input_printcommandf));
	    VBPRINTF("Setting faxdir to %s\n", fax_dir);
	    VBPRINTF("Setting faxalias to %s\n", fax_alias);
	    VBPRINTF("Setting multipage to %s\n", fl_get_button(button_multipage) ? "on" : "off");
	    VBPRINTF("Setting verbose to %s\n", verbose ? "on" : "off");
	    VBPRINTF("Setting viewcommandn: %s\n", fax_viewcommandn);
	    VBPRINTF("Setting viewcommandf: %s\n", fax_viewcommandf);
	    VBPRINTF("Setting printcommandn: %s\n", fax_printcommandn);
	    VBPRINTF("Setting printcommandf: %s\n", fax_printcommandf);
	    get_filenames();
	    break;
	} else if (act == button_save) {
	    strcpy(fax_dir, fl_get_input(input_faxdir));
	    strcpy(fax_alias, fl_get_input(input_faxalias));
	    strcpy(fax_viewcommandn, fl_get_input(input_viewcommandn));
	    strcpy(fax_printcommandn, fl_get_input(input_printcommandn));
	    strcpy(fax_viewcommandf, fl_get_input(input_viewcommandf));
	    strcpy(fax_printcommandf, fl_get_input(input_printcommandf));
	    VBPRINTF("Setting faxdir to %s\n", fax_dir);
	    VBPRINTF("Setting faxalias to %s\n", fax_alias);
	    VBPRINTF("Setting multipage to %s\n", fl_get_button(button_multipage) ? "on" : "off");
	    VBPRINTF("Setting verbose to %s\n", verbose ? "on" : "off");
	    VBPRINTF("Setting viewcommandn: %s\n", fax_viewcommandn);
	    VBPRINTF("Setting viewcommandf: %s\n", fax_viewcommandf);
	    VBPRINTF("Setting printcommandn: %s\n", fax_printcommandn);
	    VBPRINTF("Setting printcommandf: %s\n", fax_printcommandf);
	    strcpy(bakname, fax_rc);
	    strcat(bakname, ".bak");
#if 0
	    VBPRINTF("Renaming %s to %s\n", fax_rc, bakname);
	    if (rename(fax_rc, bakname) == -1) {
		fl_show_alert("Alert", "Can't rename configuration file",
			strerror(errno), 0);
	    }
#endif
	    VBPRINTF("Saving configuration to %s\n\n", fax_rc);
	    if ((fd = fopen(fax_rc, "w")) != NULL) {
		fprintf(fd, "# FaxBrowser configuration file\n");
		fprintf(fd, "verbose %s\n", verbose ? "on" : "off");
		fprintf(fd, "multipage %s\n", fl_get_button(button_multipage) ? "on" : "off");
		fprintf(fd, "faxdir %s\n", fax_dir);
		fprintf(fd, "faxalias %s\n", fax_alias);
		fprintf(fd, "viewcommandn %s\n", fax_viewcommandn);
		fprintf(fd, "viewcommandf %s\n", fax_viewcommandf);
		fprintf(fd, "printcommandn %s\n", fax_printcommandn);
		fprintf(fd, "printcommandf %s\n", fax_printcommandf);
		fclose(fd);
	    } else {
		fl_show_alert("Alert", "Can't save configuration",
			strerror(errno), 0);
	    }
	    get_filenames();
	    break;
	} else if (act == button_cancel) {
	    fl_set_button(button_multipage, button_m);
	    break;
	}
    }
    fl_hide_form(settings);
}

void update_faxdir(FL_OBJECT *ob, long data)
{
    get_filenames();
}

