#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/timeb.h>
#include "forms.h"
#include "fb.h"
#include "FaxBrowser.h"

int faxnr = 0;
int verbose = 0;
char fax_alias[MAXPATHLEN] = "";
char fax_dir[MAXPATHLEN] = "/var/spool/fax/incoming";
char fax_rc[MAXPATHLEN];
char fax_viewcommandn[MAXPATHLEN] = "viewfax -n";
char fax_viewcommandf[MAXPATHLEN] = "viewfax -f";
char fax_printcommandn[MAXPATHLEN] = "lpr";
char fax_printcommandf[MAXPATHLEN] = "lpr";
char *faxentptr[1000];

int main(int argc, char *argv[])
{
    FILE *fd;
    char buf[BUFSIZ];
    struct faxent *p;
    char *kw, *val, *lp;

    fl_initialize(&argc, argv, "FaxBrowser", 0, 0);

    create_the_forms();

    /* show the first form */
    fl_show_form(fb,FL_PLACE_CENTER,FL_FULLBORDER,"FaxBrowser v1.1.0");
    fl_set_browser_fontstyle(browser_fax, FL_FIXED_STYLE);
    fl_set_browser_fontsize(browser_fax, FL_NORMAL_SIZE);

#ifdef HSCROLLBAR
    fl_set_browser_hscrollbar(browser_fax, FL_AUTO);
#endif

    strcpy(fax_rc, getenv("HOME"));
    if (fax_rc)
	strcat(fax_rc, "/");
    else
	fax_rc[0] = '\0';
    strcat(fax_rc, FAXRC);

    VBPRINTF("Reading configuration from %s\n", fax_rc);
    if ((fd = fopen(fax_rc, "r")) != NULL) {
	while (fgets(buf, sizeof(buf), fd) != NULL )
	    if ((lp = strchr(buf, '\n')) != NULL) {
		*lp = '\0';
		if (buf[0] == '#')
		    continue;
		if ((kw = strtok(buf, " \t")) == NULL)
		    continue;
		if ((val = strtok(NULL, " \t")) == NULL)
		    continue;
		if(!strcasecmp(kw, "verbose")) {
		    if (!strcasecmp(val, "yes") || !strcasecmp(val, "on") ||
		      !strcasecmp(val, "enable") || !strcmp(val, "1"))
			verbose = 1;
		    VBPRINTF("Using verbose = %s\n", verbose ? "on" : "off");
		    continue;
		}
		if(!strcasecmp(kw, "faxdir")) {
		    strcpy(fax_dir, val);
		    VBPRINTF("Using %s as faxdir\n", fax_dir);
		    continue;
		}
		if(!strcasecmp(kw, "faxalias")) {
		    strcpy(fax_alias, val);
		    VBPRINTF("Using %s as faxalias file\n", fax_alias);
		    continue;
		}
		if(!strcasecmp(kw, "multipage")) {
		    if (!strcasecmp(val, "yes") || !strcasecmp(val, "on") ||
		      !strcasecmp(val, "enable") || !strcmp(val, "1"))
			fl_set_button(button_multipage, 1);
		    VBPRINTF("Using multipage = %s\n",
		      fl_get_button(button_multipage) ? "on" : "off");
		    continue;
		}
		if(!strcasecmp(kw, "viewcommandn")) {
		    strcpy(fax_viewcommandn, val);
		    while((val = strtok(NULL, " \t")) != NULL) {
			strcat(fax_viewcommandn, " ");
			strcat(fax_viewcommandn, val);
		    }
		    VBPRINTF("Using %s as viewcommandn\n", fax_viewcommandn);
		    continue;
		}
		if(!strcasecmp(kw, "viewcommandf")) {
		    strcpy(fax_viewcommandf, val);
		    while((val = strtok(NULL, " \t")) != NULL) {
			strcat(fax_viewcommandf, " ");
			strcat(fax_viewcommandf, val);
		    }
		    VBPRINTF("Using %s as viewcommandf\n", fax_viewcommandf);
		    continue;
		}
		if(!strcasecmp(kw, "printcommandn")) {
		    strcpy(fax_printcommandn, val);
		    while((val = strtok(NULL, " \t")) != NULL) {
			strcat(fax_printcommandn, " ");
			strcat(fax_printcommandn, val);
		    }
		    VBPRINTF("Using %s as printcommandn\n", fax_printcommandn);
		    continue;
		}
		if(!strcasecmp(kw, "printcommandf")) {
		    strcpy(fax_printcommandf, val);
		    while((val = strtok(NULL, " \t")) != NULL) {
			strcat(fax_printcommandf, " ");
			strcat(fax_printcommandf, val);
		    }
		    VBPRINTF("Using %s as printcommandf\n", fax_printcommandf);
		    continue;
		}

            }
	fclose(fd);
    }

    if (!strlen(fax_alias)) {
	strcpy(fax_alias, getenv("HOME"));
	if (fax_alias)
	    strcat(fax_alias, "/");
	else
	    fax_alias[0] = '\0';
	strcat(fax_alias, FAXALIAS);
	VBPRINTF("Using %s as faxalias file\n", fax_alias);
    }
    VBPRINTF("\n");

    get_filenames();

    signal(SIGCHLD, SIG_IGN);

    fl_set_browser_dblclick_callback(browser_fax, show_fax, 1);

    p = (struct faxent *) faxentptr[0];

    do {
	;
    } while (fl_do_forms() != button_exit);

    fl_hide_form(fb);
    return 0;
}

